#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <time.h>
using namespace std;

class item
{
        int item_code;
	int cust_id;
	int cust_balance;
	int cust_password1;
	char cust_name[25];
	int cust_balance1;
        char item_name[25];
        int price;
        int qty_available;
        int th;
        public:
        void get_data();
        void write_data();
	int update_purchase(int);
	int update_data_orderqty(int,int);
	int update_data_qty(int, int ); 
	int update_balance(int,int);      
        int rem(int,int);
	void read_data();
};
//--------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------
//this is the public function which is used to enter a item in item.dat file
void item :: get_data()
{
        cout<<"Please enter the item code : "<<endl;
        cin>>item_code;
        cout<<"Please enter the item name :"<<endl;
        cin>>item_name;
        cout<<"Pleas enter the price per item: "<<endl;
        cin>>price;
        cout<<"Please enter the quantity available"<<endl;
        cin>>qty_available;
        cout<<"Please enter the threshold quantity"<<endl;
        cin>>th;
}
//--------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------
//Defining of function to read from item.dat file
int check_data_available(int item_c)
{
        fstream f;
	int item_code1,price1,qty_available1,th1;
	char item_name1[25];
        f.open("item.dat",ios::binary|ios::in);
        cout<<"check data "<<endl;
        while (!f.eof())
        {
        f>>item_code1>>item_name1>>price1>>qty_available1>>th1;
	
        
	       
        if (item_code1 == item_c)
        {
                cout<<"name : "<<item_name1<<endl;
                cout<<"price:"<<price1<<endl;
                cout<<"qty available:"<<qty_available1<<endl;
                return 1;
        }
 	}      
        f.close();
        cout<<"insertion successfully done"<<endl;
	//cout<<"item not found"<<endl; 
	return 0;      
}
//--------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------
//this public function reads the data taken by get_data() function and write it into the file item.dat
void item :: write_data()
{
        int cnt = 1;        
        fstream f;
        cout<<"wirte data"<<endl;
        f.open("item.dat",ios::binary|ios::out|ios::app);
        while(cnt)
        {
        get_data();
	
	if (!check_data_available(item_code))
	{        
		f<<item_code<<'\t'<<item_name<<'\t'<<price<<'\t'<<qty_available<<'\t'<<th<<endl;
        	cout<<"do you want to enter more items"<<endl;
        	cin>>cnt;
	}
	else
	{
		cout<<"item code exists: primary key constraint violated"<<endl;
        }
	}        
        f.close();
}
//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
//this function only reads and show the data to the costomer 
//it is basically made for online shopping
void item::read_data()
{
	fstream f;
        f.open("item.dat",ios::binary|ios::in);
	while(!f.eof())
        {
        f>>item_code>>item_name>>price>>qty_available>>th;
        cout<<item_code<<"\t"<<item_name<<"\t"<<price<<"\t"<<qty_available<<endl;
        }
        f.close();
}
//we have a problem that last entry print double.....due to value store in buffer....
//so we make jugad:by open same file two times.......f1....f2
//we print entry of f1 first and than apply condition on f1 open and than print f2
//so file print one time less........so last entry print only one time
int item :: update_purchase(int item_c)
{
        fstream f,f1,fjugad;
        f.open("purchase_queue.dat",ios::binary|ios::in|ios::out|ios::app);
        f1.open("purchase_queue1.dat",ios::binary|ios::out);        
	fjugad.open("purchase_queue.dat",ios::binary|ios::in);
	fjugad>>item_code>>item_name>>th;   
	while (!fjugad.eof())
        {
	fjugad>>item_code>>item_name>>th;
        f>>item_code>>item_name>>th;
     
        if (item_code == item_c)
	{
	       continue;                
        }
        else
        {
                        
                f1<<item_code<<'\t'<<item_name<<'\t'<<th<<endl;        
        }
        }
        f.close();
        f1.close();        
        system ("mv purchase_queue1.dat purchase_queue.dat");
	return 1;
}
//we have a problem that last entry print double.....due to value store in buffer....
//so we make jugad:by open same file two times.......f1....f2
//we print entry of f1 first and than apply condition on f1 open and than print f2
//so file print one time less........so last entry print only one time
int item :: update_balance(int balance,int check_cust_id)
{
        fstream f,f1,fjugad;
        f.open("cust.dat",ios::binary|ios::in|ios::out|ios::app);
        f1.open("cust1.dat",ios::binary|ios::out);        
	fjugad.open("cust.dat",ios::binary|ios::in);
	fjugad>>cust_id>>cust_name>>cust_password1>>cust_balance1;   
	while (!fjugad.eof())
        {
	fjugad>>cust_id>>cust_name>>cust_password1>>cust_balance1;
        f>>cust_id>>cust_name>>cust_password1>>cust_balance1;
     
        if (cust_id == check_cust_id)
	{
	        f1<<cust_id<<'\t'<<cust_name<<'\t'<<cust_password1<<'\t'<<(cust_balance1-balance)<<endl;                
        }
        else
        {
                        
                f1<<cust_id<<'\t'<<cust_name<<'\t'<<cust_password1<<'\t'<<cust_balance1<<endl;        
        }
        }
        f.close();
        f1.close();        
        system ("mv cust1.dat cust.dat");
	return 1;
}
//we have a problem that last entry print double.....due to value store in buffer....
//so we make jugad:by open same file two times.......f1....f2
//we print entry of f1 first and than apply condition on f1 open and than print f2
//so file print one time less........so last entry print only one time
int item :: update_data_orderqty(int item_c,int qty)
{
        fstream f,f1,fjugad;
        f.open("item.dat",ios::binary|ios::in|ios::out|ios::app);
        f1.open("item1.dat",ios::binary|ios::out);        
	fjugad.open("item.dat",ios::binary|ios::in);
	fjugad>>item_code>>item_name>>price>>qty_available>>th;   
	while (!fjugad.eof())
        {
	fjugad>>item_code>>item_name>>price>>qty_available>>th;
        f>>item_code>>item_name>>price>>qty_available>>th;
     
        if (item_code == item_c)
	{
	        f1<<item_code<<'\t'<<item_name<<'\t'<<price<<'\t'<<(qty_available+qty)<<'\t'<<th<<endl;                
        }
        else
        {
                        
                f1<<item_code<<'\t'<<item_name<<'\t'<<price<<'\t'<<qty_available<<'\t'<<th<<endl;        
        }
        }
        f.close();
        f1.close();        
        system ("mv item1.dat item.dat");
	return 1;
}
//we have a problem that last entry print double.....due to value store in buffer....
//so we make jugad:by open same file two times.......f1....f2
//we print entry of f1 first and than apply condition on f1 (open) and than print f2
//so file print entry one time less........so last entry print only one time
int item :: update_data_qty(int item_c,int qty)
{
        fstream f,f1,fjugad;
        f.open("item.dat",ios::binary|ios::in|ios::out|ios::app);
        f1.open("item1.dat",ios::binary|ios::out);        
	fjugad.open("item.dat",ios::binary|ios::in);
	fjugad>>item_code>>item_name>>price>>qty_available>>th;   
	while (!fjugad.eof())
        {
	fjugad>>item_code>>item_name>>price>>qty_available>>th;
        f>>item_code>>item_name>>price>>qty_available>>th;
     
        if (item_code == item_c)
              {                                                                                                                                                                                                                                                                                                                                                     
                cout<<"name : "<<item_name<<endl;
                cout<<"price:"<<price<<endl;
                cout<<"qty available:"<<qty_available<<endl;
                cout<<"thresh: "<<th<<endl;
		if (qty_available<qty)
		{
			cout<<"sorry........not enough qty"<<endl;
			cout<<"qty available = "<<qty_available<<endl;
			return 0;
		}
		fstream purchase_check;
		purchase_check.open("purchase_queue.dat",ios::binary|ios::in);
		int qty_avail;
		int item_p_c;
		char item_p_name[25];
		int noentry;
		/*cout<<"avail"<<qty_available<<endl;
		cout<<"qty"<<qty<<endl;
		cout<<"th"<<th<<endl;*/		
		if (qty_available - qty < th)
		{
		noentry = 0;
		while(!purchase_check.eof())
		{
			purchase_check>>item_p_c>>item_p_name>>qty_avail;			
			if (item_c == item_p_c)
			{
				noentry = 1;
				break;
			}
		}
		purchase_check.close();
		cout<<" warning qty less than threshold"<<endl;
		cout<<"order reminder placed in queue"<<endl;			
		if (!noentry)
		{			
			fstream purchase_queue;
			purchase_queue.open("purchase_queue.dat",ios::binary|ios::out|ios::app);
			purchase_queue<<item_c<<'\t'<<item_name<<'\t'<<qty_available<<endl;
			purchase_queue.close();
		}
		}
                f1<<item_code<<'\t'<<item_name<<'\t'<<price<<'\t'<<(qty_available-qty)<<'\t'<<th<<endl;                
        }
        else
        {
                        
                f1<<item_code<<'\t'<<item_name<<'\t'<<price<<'\t'<<qty_available<<'\t'<<th<<endl;        
        }
        }
        f.close();
        f1.close();        
        system ("mv item1.dat item.dat");
	return 1;
}
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------
// This function is used to read data from the item.dat file and match the coreesponding item_code entered by the user 
// This function return value of price of item at the end
// This function  open a bill.dat file which stores all the bills formed
// This function also open a individual_bill.dat file which stores the current customer's bill 
int get_attributes1(int item_c,int item_qty,int i)
{
        fstream f,f1,f2;
	int item_code,price,qty_available,th;
        int total;
	char item_name[25];
	f.open("item.dat",ios::binary|ios::in);
        f1.open("bill.dat",ios::binary|ios::out|ios::app);
        while (!f.eof() && !f1.eof())
        {
	 f>>item_code>>item_name>>price>>qty_available>>th;        
         if (item_code == item_c)
         {
                
                total=item_qty*price;
                if(qty_available>=item_qty)
                    {
                     f1<<i<<'\t'<<item_code<<'\t'<<item_name<<'\t'<<price<<'\t'<<item_qty<<'\t'<<total<<endl;
                    }
                return price;
         }
        }
        f.close(); 
        f1.close();  
        return 0;
        
}
//--------------------------------------------------------------------------------------------------------------
// DEFINING OF CLASS CUST WHICH IS MEANT FOR USING CUSTOMER INFO INTO OUR PROGRAM AND PROVIDE CUSTOMER PRIORITY SERVICES 
class cust
{
        int cust_id;
        char name[25];
        int password;
        int balance;
        public:
        void get_data();
        void write_data(int);
        int check_data(int);
	int online_check_data(int);
	int check_data(int,int*);
        int rem(int,int);
};
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
// Public function to read infromation about a customer 
void cust :: get_data()
{
        //cout<<"cust_id : "<<endl;
        //cin>>cust_id;
        cout<<"Please Enter Your Name :"<<endl;
        cin>>name;
        cout<<"Please enter a suitable password : "<<endl;
        cin>>password;
        cout<<"Please enter the balance for your account:"<<endl;
        cout<<"Rs"<<" ";
        cin>>balance;
}
//--------------------------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------
//  Public function to write information about a customer into a cust.dat file
void cust :: write_data(int j)
{
        int cnt = 1;        
        fstream f;
        cout<<"wirte data"<<endl;
        f.open("cust.dat",ios::binary|ios::out|ios::app);
        while(cnt)
        {
        get_data();
        f<<j<<'\t'<<name<<'\t'<<password<<'\t'<<balance<<endl;
        cout<<"welcome"<<"\t";
        cout<<name<<endl;
        cout<<"Your account have been successfully created"<<endl;
        cout<<"You are now a priority customer of our shopping system"<<endl;
        cout<<"Now you can shop from our shopping system on credit"<<endl;
        cout<<"Amount will be automatically reduced from balance in your account"<<endl;
        cout<<"details are updated"<<endl;
        cnt--;
        }        
        f.close();
	
}
//-------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------------
int cust :: check_data(int item_c)
{
        fstream f;
        f.open("cust.dat",ios::binary|ios::in);
        while (!f.eof())
        {
        f>>cust_id>>name>>password>>balance;
       // cout<<"cust_id"<<cust_id<<endl;        
        if (cust_id == item_c)
        {
                cout<<"name : "<<name<<endl;
                cout<<"balance:"<<balance<<endl;
                return password;
        }
        }
        f.close();
        return 0;      
}
//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
int cust :: check_data(int item_c,int*a)
{
        int*b;
        fstream f;
        f.open("cust.dat",ios::binary|ios::in);
        while (!f.eof())
        {
        f>>cust_id>>name>>password>>balance;
       // cout<<"cust_id"<<cust_id<<endl;        
        if (cust_id == item_c)
        {
                cout<<"name : "<<name<<endl;
                cout<<"balance:"<<balance<<endl;
                b=&balance;
                *a=*b;
                
                return password;
        }
        }
        f.close();
        return 0;
}
//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
int cust :: online_check_data(int item_c)
{
        
        fstream f;
        f.open("cust.dat",ios::binary|ios::in);
        while (!f.eof())
        {
        f>>cust_id>>name>>password>>balance;
           
        if (cust_id == item_c)
        {
            return balance;            
        }
        }
        f.close();
        return 0;      
}
//----------------------------------------------------------------------------------------------------------------
// DEFINING OF SUPPLIER CLASS TO STORE INFO REARDING SUPPLIERS SO THAT NEW ORDERS CAN BE PLACED 
class supplier
{
        int item_code;
        char supplier[25];
        char supplier_name[25];
        int supplier_contact;
       
        public:
        void get_data();
        void write_data();
        
};
// --------------------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------
// This Public function takes info rearding a supplier
void supplier :: get_data()
{
        cout<<"item code "<<endl;
        cin>>item_code;
        cout<<"supplier :"<<endl;
        cin>>supplier;
        cout<<"supplier name : "<<endl;
        cin>>supplier_name;
        cout<<"contact"<<endl;
        cin>>supplier_contact;
}
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
// This Public function write taken info into a file 
void supplier :: write_data()
{
        int cnt = 1;        
        fstream f;
        cout<<"wirte data"<<endl;
        f.open("supplier.dat",ios::binary|ios::out|ios::app);
        while(cnt)
        {
        get_data();
        f<<item_code<<'\t'<<supplier<<'\t'<<supplier_name<<'\t'<<supplier_contact<<endl;
        cout<<"do you want to enter new suplier informations"<<endl;
        cin>>cnt;
        }        
        f.close();
}
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
// This function print a line of '*'
void print_line()
{ 
	int i;
	for(i=0;i<100;i++)
	{
		cout<<"*";
        }
                cout<<endl;
};
//-----------------------------------------------------------------------------------------------------------------------
// Main algo starts from here
int main()
{
	item i;				// Class item has been called 
	cust t;				// Class cust has been called
	int item_code_order;
	int pitem_code,pitem_qty;
	int sitem_code,sitem_contact;
	char sitem_address[25];		//storing supplier address
	char sitem_name[25];		//storing supplier name
	char pitem_name[25];
	int qty_order;			//storing quantity order
	int qty;   			//storing quantity of item
	int check_pass,value;		//storing item name
	int price;			//storing price of item
        char cust_name[25];		//storing customer name 
	int cust_id;			//storing customer id
	int password;			//storing customer password
	int total_amount=0;		//storing amount paid by customer
        int ch;
	char c='y';
        char cont='y';
        int itmc,r;
	int online_check_balance;
        int bill_number=0;
	int password_check=2;
        int cust_id1=1000;
        int check_balance;
        int x,y;
	int code_view;
	int th_view;
        int custID;
        char name[25];
	int pwd;
	int balance;
	int item_cd;
	char s_name[25];
	char s_add[25];
	int s_no;
	int billno;
	int item_c;
	char item_n[25];
	int bprice;
	int qty_r;
	int t_amt;
        fstream f1,f2;
        
    	
    	char item_name[25];
        
        char membership;
	
         
    	f1.open("bill.dat",ios::binary|ios::in);
        //...............
	while(!f1.eof())
	{
		f1>>bill_number>>x>>item_name>>x>>x>>x;
	}
	bill_number++;
	
	f1.close();
		
        while(cont=='y')
  {
	
	
	f2.open("cust.dat",ios::binary|ios::in);
        while(!f2.eof())
	{
		f2>>cust_id1>>cust_name>>y>>y;
	}
	cust_id1++;
	
	f2.close();

        print_line();
	cout<<"\t"<<"\t"<<"\t"<<"\t"<<"WELCOME TO CS101 SHOPPING SYSYTEM"<<endl;
        print_line();
        cout<<"\t"<<"\t"<<"\t"<<"USING INVENTARY CONTROLL SYSTEM PREPARED BY BATCH 552"<<endl;
        print_line();
        cout<<"\t"<<"\t"<<"\t"<<"ENTER YOUR CHOICE"<<endl;
        cout<<"\t"<<"\t"<<"Press 1."<<"\t"<<"To enter a new item into the shopping system"<<endl; 
        cout<<"\t"<<"\t"<<"Press 2."<<"\t"<<"For handy billing for the customer"<<endl; 
        cout<<"\t"<<"\t"<<"Press 3."<<"\t"<<"To open a new piority customer account"<<endl; 
	cout<<"\t"<<"\t"<<"Press 4."<<"\t"<<"To enter a new supplier entry"<<endl;
        cout<<"\t"<<"\t"<<"Press 5."<<"\t"<<"For online shopping"<<endl;
	cout<<"\t"<<"\t"<<"Press 6."<<"\t"<<"placing order"<<endl;
	cout<<"\t"<<"\t"<<"Press 7."<<"\t"<<"order"<<endl;
	cout<<"\t"<<"\t"<<"Press 8."<<"\t"<<"view"<<endl;
        print_line();
        cin>>ch;     
   if (ch ==1 )
        {
              
                i.write_data();
        }
        char endbill='y';
   if(ch ==2) 
        {
        cout<<"bill_number_intial="<<bill_number<<endl; 
	time_t *xdt;
	time_t ydt;
	ydt=time(xdt);
	char* wdt;
	wdt=ctime(&ydt);
	cout<<wdt;
	fstream fdate;
	fdate.open("billdate.dat",ios::binary|ios::out|ios::app);
	fdate<<" "<<bill_number<<'\t'<<wdt;
	fdate.close();
        	do
        	  {
        	  	
        	  
                	cout<<"enter item code & qty :"<<endl;
                	cin>>itmc>>qty;
                	price = get_attributes1(itmc,qty,bill_number);
                	if (!i.update_data_qty(itmc,qty))
		         {
			  continue;
		         }
                	cout<<"amount = "<<price *qty;
                 	total_amount =  total_amount + price*qty;cout<<endl;
                	cout<<"wants to buy more item..........y or n"<<endl;
        		cin>>endbill;
        	  }while(endbill == 'y');
	fstream f,f1;
	int bill_number1,item_code1,price1,qty1,total1;
	char item_name1[25];
       	f.open("bill.dat",ios::binary|ios::in);
      	f1.open("bill.dat",ios::binary|ios::in);
	f1>>bill_number1>>item_code1>>item_name1>>price1>>qty1>>total1;
	fstream fdatedisp;
	cout<<"open"<<endl;
	fdatedisp.open("billdate.dat",ios::binary|ios::in);
	while(!fdatedisp.eof())
		{		
			char x[5][25];			
			fdatedisp>>bill_number1>>x[0]>>x[1]>>x[2]>>x[3]>>x[4];
			if (bill_number==bill_number1)
			{
			cout<<"bill_number = "<<bill_number<<endl;
			cout<<x[0]<<' '<<x[1]<<' '<<x[2]<<' '<<x[3]<<' '<<x[4]<<endl;
			break;
			}
		}
	fdatedisp.close();
	while (!f1.eof())
             {
			f1>>bill_number1>>item_code1>>item_name1>>price1>>qty1>>total1;               
			f>>bill_number1>>item_code1>>item_name1>>price1>>qty1>>total1; 
		               
			if (bill_number1 == bill_number)
              		{
               			cout<<item_code1<<'\t'<<item_name1<<'\t'<<price1<<'\t'<<qty1<<'\t'<<total1<<endl;
              		}
             }
        f.close();
	f1.close();
        cout<<"your amount is: ";
        cout<<total_amount<<endl;
        cout<<"ask the customer if he has a customer id....y or n "<<endl;
        cin>>c;
        
            if ( c == 'y')
             {
        	
                cout<<"enter customer_id"<<endl;
                cin>>cust_id;
                password = t.check_data(cust_id,&check_balance);;
                cout<<"enter your password"<<endl;
                cin>>check_pass; 
                    if(check_pass == password )
                     {
                    	if(check_balance<=total_amount)
			    {
                             cout<<"not enough balance please pay by cash.."<<endl;
                             return 1;
                            }
                        cout<<"transaction successful"<<endl;
			i.update_balance(total_amount,cust_id);
                        return 1;
                     }
                    else
                     {
                      cout<<"sorry incorrect password"<<endl;
                     }
		  
             }
            else
                {
                  cout<<"paid by cash"<<endl;
                  cout<<"want membership..y or n"<<endl;
                 cin>>membership;
                  if(membership=='y')
                      {
                      	cout<<"cust_id: "<<cust_id1<<endl;
			            t.write_data(cust_id1);
			return 1;
		       }


                  else if(membership=='n')
                      {
                       cout<<"thank you for shopping:)";
                      }
        total_amount=0;
        bill_number++;      
		}
        }
     
   if ( ch == 3 )
        {
          cout<<"cust_id: "<<cust_id1<<endl;
          t.write_data(cust_id1);
          print_line();
        }
   if ( ch == 4 )
        {
          supplier s;
          s.write_data();
          print_line();
        }
   if ( ch == 5 )
        {
		int u,t;
    		char name[25];
   		int cust_id;
   		int password;
    		int check_pass;	
    		cout<<"\t"<<"\t"<<"\t"<<"\t"<<"\t"<<"*********************************"<<endl;
    		cout<<"\t"<<"\t"<<"\t"<<"\t"<<"\t"<<"WELCOME TO ONLINE SHOPPING SYSTEM"<<endl;
   		cout<<"\t"<<"\t"<<"\t"<<"\t"<<"\t"<<"*********************************"<<endl;
    		cout<<"Please choose your option"<<"\t"<<"1.SIGN IN"<<"\t"<<"2.SIGN UP"<<endl;
                print_line();
    		cin>>u;
    		if(u == 1)
			 { 
                		item i;
				cust t;
				cout<<"ENTER YOUR CUSTOMER ID"<<endl;
				cin>> cust_id;
				//cout<<"ENTER YOUR NAME"<<endl;
				//cin>>name;
                                cout<<"ENTER YOUR PASSWORD........INTEGER VALUE"<<endl;
				cin>>check_pass; 
                                password=t.check_data(cust_id);
                                     while(password_check%2==0)
 					{
                    			if(check_pass == password )
                   			 { 
                     				cout<<"welcome"<<"\t"<<name<<"\t";
						cout<<"To Cs101 sHoPpInG SyStEm"<<endl;
						print_line();
						cout<<"LiSt oF aLl tHe iTeMs available In our ShoppIng system is show Below"<<endl;
						i.read_data();
						cout<<"Enter the item code number and the required quantity which you wish to buy"<<endl;
						cout<<"bill_number_intial="<<bill_number<<endl; 
						time_t *xdt;
						time_t ydt;
						ydt=time(xdt);
						char* wdt;
						wdt=ctime(&ydt);
						cout<<wdt;
						fstream fdate;
						fdate.open("billdate.dat",ios::binary|ios::out|ios::app);
						fdate<<" "<<bill_number<<'\t'<<wdt;
						fdate.close();
        					do
        	  				 {
        	  	
        	  
                				     cout<<"enter item code & qty :"<<endl;
                				     cin>>itmc>>qty;
                				     price = get_attributes1(itmc,qty,bill_number);
                				     if (!i.update_data_qty(itmc,qty))
		        		               {
			 			           continue;
		         			       }
                				     cout<<"amount = "<<price *qty;
                 				     total_amount =  total_amount + price*qty;cout<<endl;
						     online_check_balance=t.online_check_data(cust_id);
 							if(online_check_balance<total_amount)
							      {
								cout<<"not enough balance....."<<endl;
							      }
                				     cout<<"wants to buy more item..........y or n"<<endl;
        					     cin>>endbill;
						     
        	  				 }
                                                while(endbill == 'y');
						 fstream f,f1;
						 int bill_number1,item_code1,price1,qty1,total1;
						 char item_name1[25];
       						 f.open("bill.dat",ios::binary|ios::in);
     					 	 f1.open("bill.dat",ios::binary|ios::in);
						 f1>>bill_number1>>item_code1>>item_name1>>price1>>qty1>>total1;
						 fstream fdatedisp;
						 cout<<"open"<<endl;
						 fdatedisp.open("billdate.dat",ios::binary|ios::in);
						 while(!fdatedisp.eof())
						      {		
						          char x[5][25];			
						          fdatedisp>>bill_number1>>x[0]>>x[1]>>x[2]>>x[3]>>x[4];
						          if (bill_number==bill_number1)
						              {
						                 cout<<"bill_number = "<<bill_number<<endl;
						                 cout<<x[0]<<' '<<x[1]<<' '<<x[2]<<' '<<x[3]<<' '<<x[4]<<endl;
						                 break;
						              }
						      }
						 fdatedisp.close();
						 while (!f1.eof())
             					      {
						            f1>>bill_number1>>item_code1>>item_name1>>price1>>qty1>>total1;               
						            f>>bill_number1>>item_code1>>item_name1>>price1>>qty1>>total1; 
		               
						            if (bill_number1 == bill_number)
              					              {
               					                cout<<item_code1<<'\t'<<item_name1<<'\t'<<price1<<'\t'<<qty1<<'\t'<<total1<<endl;
              					              }
             					      }
        					 f.close();
						 f1.close();
       					         cout<<"your amount is: ";
        					 cout<<total_amount<<endl;
						 i.update_balance(total_amount,cust_id); 
                                                 password_check--;        						
                    			 }
                    			else
                   			    {
                    				cout<<"sorry incorrect password"<<endl;
						cout<<"Try again"<<endl;
 						cout<<"ENTER YOUR CUSTOMER ID"<<endl;
				                cin>> cust_id;
				                cout<<"ENTER YOUR NAME"<<endl;
				                cin>>name;
                		                cout<<"ENTER YOUR PASSWORD......INTEGER VALUE"<<endl;
				                cin>>check_pass; 
                		                password=t.check_data(cust_id);
					    }
					}
                    			   
                         }                         
	 	if (u == 2) 
		         {
	 		 	cust t;
	 		 	cout<<"cust_id: "<<cust_id1<<endl;
                         	t.write_data(cust_id1);
                         	print_line();;
	 	         }
	}
   if(ch==6)
       {
	fstream fpurchase,fsupplier,forder,fsupplierjugad,fpurchasejugad;
	fpurchase.open("purchase_queue.dat",ios::binary|ios::in);
	fpurchasejugad.open("purchase_queue.dat",ios::binary|ios::in);
	forder.open("order.dat",ios::binary|ios::out|ios::app);
	fpurchasejugad>>pitem_code>>pitem_name>>pitem_qty;
	while(!fpurchasejugad.eof())
	 {		
		fpurchasejugad>>pitem_code>>pitem_name>>pitem_qty;		
		fpurchase>>pitem_code>>pitem_name>>pitem_qty;
		fsupplier.open("supplier.dat",ios::binary|ios::in);
		fsupplierjugad.open("supplier.dat",ios::binary|ios::in);
		fsupplierjugad>>sitem_code>>sitem_name>>sitem_address>>sitem_contact;
		while(!fsupplierjugad.eof())
		 {
			fsupplierjugad>>sitem_code>>sitem_name>>sitem_address>>sitem_contact;
			fsupplier>>sitem_code>>sitem_name>>sitem_address>>sitem_contact;
	                if(pitem_code==sitem_code)
			   {
				cout<<"item name: "<<pitem_name<<endl;
			   	cout<<"name:"<<sitem_name<<endl;
			   	cout<<"address: "<<sitem_address<<endl;
				cout<<"contact: "<<sitem_contact<<endl;
				cout<<"how many qty. order"<<endl;
				cin>>qty_order;
				if (qty_order==0)
				{
					continue;
				}
				if(qty_order!=0)
				{
				i.update_data_orderqty(sitem_code,qty_order);
				i.update_purchase(sitem_code);
                                }
                                forder<<pitem_name<<'\t'<<sitem_name<<'\t'<<sitem_address<<'\t'<<sitem_contact<<'\t'<<qty_order<<endl;
			   }
		}
		fsupplier.close();
		fsupplierjugad.close();
	}
        fpurchase.close();
	fpurchasejugad.close();
	forder.close();
       }
   if(ch==7)
       {
       	cout<<"enter item code"<<endl;
        cin>>item_code_order;
	fstream fsupplier,forder,fsupplierjugad;
	fsupplier.open("supplier.dat",ios::binary|ios::in);
	forder.open("order.dat",ios::binary|ios::out|ios::app);
	while(!fsupplier.eof())
	   {
		fsupplier>>sitem_code>>sitem_name>>sitem_address>>sitem_contact;
   		if(item_code_order==sitem_code)
		 {
			
			//cout<<"item name: "<<pitem_name<<endl;
			cout<<"name:"<<sitem_name<<endl;
			cout<<"address: "<<sitem_address<<endl;
			cout<<"contact: "<<sitem_contact<<endl;
			cout<<"how many qty. order"<<endl;
			cin>>qty_order;
			if (qty_order==0)
				{
					continue;
				}
				if(qty_order!=0)
				{
				i.update_data_orderqty(sitem_code,qty_order);
				i.update_purchase(sitem_code);
                                }
				forder<<""<<'\t'<<sitem_name<<'\t'<<sitem_address<<'\t'<<sitem_contact<<'\t'<<qty_order<<endl;
		 }
	   } 
	    forder.close();
	    fsupplier.close();
       }
   if(ch==8)
       {
	int view;
	cout<<"1.Display Item details file"<<endl;
        cout<<"2.Display Customer details file"<<endl;
        cout<<"3.Display Supplier details file"<<endl;
        cout<<"4.Display Billing Record file"<<endl;
        cin>>view;
        if(view==1)
	 {
		cout<<"code"<<'\t'<<"name"<<'\t'<<"price"<<'\t'<<"qty"<<'\t'<<"th"<<endl;
		fstream fitem,fitem1;
		fitem.open("item.dat",ios::binary|ios::in);
		fitem1.open("item.dat",ios::binary|ios::in);
                fitem1>>code_view>>item_name>>price>>qty>>th_view;
		while(!fitem1.eof())
		 {
			fitem>>code_view>>item_name>>price>>qty>>th_view;
			cout<<code_view<<'\t'<<item_name<<'\t'<<price<<'\t'<<qty<<'\t'<<th_view<<endl;
			fitem1>>code_view>>item_name>>price>>qty>>th_view;
		 }
		 fitem.close();
		 fitem1.close();
         }
        if(view==2)
         {
                 cout<<"custID"<<'\t'<<"name"<<'\t'<<"pwd"<<'\t'<<"balance"<<endl;
                 fstream fcust, fcust1;
                 fcust.open("cust.dat",ios::binary|ios::in);
		 fcust1.open("cust.dat",ios::binary|ios::in);
                 fcust1>>custID>>name>>pwd>>balance;
                 while(!fcust1.eof())
                 {
                        fcust>>custID>>name>>pwd>>balance;
                        cout<<custID<<'\t'<<name<<'\t'<<pwd<<'\t'<<balance<<endl;
                        fcust1>>custID>>name>>pwd>>balance;
                 }
                 fcust.close();
		 fcust1.close();

         }
        if(view==3)
	 {
		cout<<"item_cd"<<'\t'<<"s_name"<<'\t'<<"s_add"<<'\t'<<"s_no"<<endl;
		fstream fsupp, fsupp1;
                fsupp.open("supplier.dat",ios::binary|ios::in);
                fsupp1.open("supplier.dat",ios::binary|ios::in);
                fsupp1>>item_cd>>s_name>>s_add>>s_no;
                while(!fsupp1.eof())
		{
                        fsupp>>item_cd>>s_name>>s_add>>s_no;
                        cout<<item_cd<<'\t'<<s_name<<'\t'<<s_add<<'\t'<<s_no<<endl;
			fsupp1>>item_cd>>s_name>>s_add>>s_no;
		}
                fsupp.close();
		fsupp1.close();
	 }
	 if(view==4)
	 {
		cout<<billno<<'\t'<<item_c<<'\t'<<item_n<<'\t'<<bprice<<'\t'<<qty_r<<'\t'<<t_amt<<endl;
		fstream fbill, fbill1;
                fbill.open("bill.dat",ios::binary|ios::in);
                fbill1.open("bill.dat",ios::binary|ios::in);
                fbill1>>billno>>item_c>>item_n>>bprice>>qty_r>>t_amt;
                while(!fbill.eof())
		{
                        fbill>>billno>>item_c>>item_n>>bprice>>qty_r>>t_amt;
                        cout<<billno<<'\t'<<item_c<<'\t'<<item_n<<'\t'<<bprice<<'\t'<<qty_r<<'\t'<<t_amt<<endl;
			fbill1>>billno>>item_c>>item_n>>bprice>>qty_r>>t_amt;
		}
                fbill.close();
		fbill1.close();
	 }

       }     	
   
  print_line(); 
  cout<<"do you want to continue.........y or n"<<endl;
  cin>>cont;
 }   
 return 0;
}

